/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */
    function onInitComponent(oComponent){
        //console.log("%c/components/"+ oComponent.getType() +"/initialization","color:purple");
        
        //Call common initialize component inside mainframe
        
        //Set default values
        oComponent.addParamVal("history",false);
        oComponent.addParamVal("savelastvalue",false);
        oComponent.addParamVal("cache",false);
        
        //Select default Url gateway
        oComponent.addParamVal("gateway",application.getGatewaysByProtocol("video")[0]);
        
        //Set default values
        oComponent.addParamVal("name", _D("IP Camera")+" "+oComponent.UId);
        //Set default icons set
        oComponent.addParamVal("icons", new Array());
        
        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();
        
        var panw=model["instance"].skin.IconsPan[0].imgWidth;
        var panh=model["instance"].skin.IconsPan[0].imgHeight;
        var iconw=model["instance"].skin.IconsPan[0].iconsWidth;
        var iconh=model["instance"].skin.IconsPan[0].iconsHeight;

		var i0=model["instance"].skin.IconsPan[0].ComponentsInfo.IPCamera.defaultIcons[0];
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });
        
        //Important: mantain original position
        aIcons.push(oIcon_status_0);

        oComponent.addParamVal("viewmodelist",[ 
            {id:0, label:"Classic"}
            ,{id:1, label:"Modal"}
            //,{id:2, label:"Only Text"}
            //,{id:3, label:"Hidden"}
        ]);
        
        oComponent.addParamVal("local-url", "http://");
        oComponent.addParamVal("local-video-format","auto");
        oComponent.addParamVal("remote-url", "http://");
        oComponent.addParamVal("remote-video-format","auto");
        oComponent.addParamVal("local-url-list","");
        
        //Add parameter for textarea
        //oComponent.addParamVal("","");

        //Ghost
        oComponent.addParamVal("ghost/virtual-feedback",true);

        oComponent.addParamVal("uiDisableCircle",true);
    };
}
catch(err){
    console.error(err);
}
