/** Update component component properties */
try{

    // Init component \see data in component html
    function onInitComponent(data){
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        return true;
    }
    // compones-mainframe.html callback
    function onGuiChangeGateway(sender,gateway,data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        //return updateProtocol(gateway.getProtocol(),data);
        return true;
    }
    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data){

        var oComponent = data.node();

        //Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);

        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));
        

        //Set html name
        $Elem = $("#"+ oComponent.id +" .components-text");
        $Elem.text(oComponent.getParamVal("name"));
        
        //Build gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");
        
        //Set gateways
        var $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
        $componentProperties.find(".protocols").hide();                                             //Hide all protocols
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");
            var strProtocol;
            
            //Find gateway
            if(oNode === oComponent.getParamVal("gateway")){
                
                $currElem.prop("selected",true);                                                    //Select gateway
                if(oNode == undefined){ break; }                                                    //If none gateway is selected break for cycle
                
                var oGateway = oNode.getData();                                                     //Get node data (gateway)
                
                strProtocol = oGateway.getProtocol();                                               //Get protocol id
                $componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();     //Show protocol view
                break;
            }
        }
        
        //Set enable history
        $Elem = $componentProperties.find("[eve-manager-id='history']");
        $Elem.prop("checked",oComponent.getParamVal("history"));
        
        //Set enable save last value
        $Elem = $componentProperties.find("[eve-manager-id='savelastvalue']");
        $Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
        
        //Set enable cache
        $Elem = $componentProperties.find("[eve-manager-id='cache']");
        $Elem.prop("checked",oComponent.getParamVal("cache"));



        //Set customData
        $Elem = $componentProperties.find("[eve-manager-id='customData']");
        $Elem.prop("value",oComponent.getParamVal("customData"));

      
        
        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);




        var $container = $("[eve-manager-protocol='gui']");

        var comboParams=([

            {label:"Et4(t) Active energy in T4 of the previous period"       ,uid:"gui/S000R005"                 ,type:"info"},
            {label:"Et3(t) Active energy in T3 of the previous period"       ,uid:"gui/S000R004"                 ,type:"info"},
            {label:"Et2(t) Active energy in T2 of the previous period"       ,uid:"gui/S000R003"                 ,type:"info"},
            {label:"Et1(t) Active energy in T1 of the previous period"       ,uid:"gui/S000R002"                 ,type:"info"},
            {label:"E(t) Total active energy of actual period"              ,uid:"gui/S000R001"                 ,type:"info"},

            {label:"Connection state"                                       ,uid:"gui/connectionState"          ,type:"info"},
                {label:"Serial port"                                            ,uid:"gui/serialName"               ,type:"info"},
                {label:"Last connection time"                                   ,uid:"gui/lastConnection"           ,type:"info"},
                {label:"Instant consumption Alarm"                              ,uid:"gui/instantAlarm"             ,type:"switch"},
                {label:"Daily Consumption Alarm"                                ,uid:"gui/dailyConsumptionAlarm"    ,type:"switch"},
                {label:"Total daily active energy current date*"                ,uid:"gui/S000R101"                 ,type:"info"},
                {label:"Total daily active energy previous date"                ,uid:"gui/S000R103"                 ,type:"info"},
                {label:"Instant power (Average in time Tx, 1 second) – PTx*"    ,uid:"gui/S000R105"                 ,type:"info"},
                {label:"POD (Point of Delivery)"                                ,uid:"gui/S001R022"                 ,type:"info"},
                {label:"Contractual power"                                      ,uid:"gui/S001R001"                 ,type:"info"},
                {label:"Available power"                                        ,uid:"gui/S001R002"                 ,type:"info"},
                {label:"Average power (in time T1m, default 2 minutes) -PT1m"   ,uid:"gui/S000R011"                 ,type:"info"},
                {label:"Et4(t) Active energy in T4 of the current period"       ,uid:"gui/S000R010"                 ,type:"info"},
                {label:"Et3(t) Active energy in T3 of the current period"       ,uid:"gui/S000R009"                 ,type:"info"},
                {label:"Et2(t) Active energy in T2 of the current period"       ,uid:"gui/S000R008"                 ,type:"info"},
                {label:"Et1(t) Active energy in T1 of the current period"       ,uid:"gui/S000R007"                 ,type:"info"},
                {label:"E(t) Total active energy of current period"              ,uid:"gui/S000R006"                 ,type:"info"}


        ]);














        var $container = $("[eve-manager-protocol='gui']");

        /* Components */
        var customInsideData="";
        $Elem = $componentProperties.find("[eve-manager-id='gui/components-list']");
        var aWidgetComponents = oComponent.getParamVal("gui/components-list");
        for(var i=0; i<comboParams.length; ++i){
            console.log(comboParams[i]);

            var $label = $('<span>' + comboParams[i].label + '</span>');
            var $select = $('<select></select>');
            var componentType = comboParams[i].type;

            //$label.text( _D( componentType.capitalizeFirst() ) );
            $label.addClass("widget-components");

            //Get all created components
            var aComponent = application.getComponentsByType( componentType );

            //Append select
            //$select.addClass("widget-components");
            $select.attr("eve-manager-id","gui/components");
            $select.attr("onchange","setDropDownParam(this);");
            $select.data("componentType",comboParams[i]);

            $container.prepend($select);
            $container.prepend($label);

            //$container.append("<br class='widget-components' /><br class='widget-components' />");



            $select.append($("<option>None</option>"));


            for(var j=0; j<aComponent.length; ++j){
                var oNode = aComponent[j];
                var oParent = oNode.getParent();
                var oComponentExt = oNode.getData();
                var label = oComponentExt.getParamVal("name");

                //console.log(oParent);
                if(oParent.getData() instanceof Component){
                    label = oParent.getData().getParamVal("name") +" - "+ label;
                }

                //var $option = $("<option>"+ oComponentExt.getParamVal("name") +"</option>");
                var $option = $("<option>"+ label +"</option>");

                $option.val(oComponentExt.UId);
                $option.data("eveManagerNode",oComponentExt);
                $select.append($option);
            }
        }

        $container.prepend('<h5 style="margin-top: 0px;">Components</h5>');

        $Elem = $componentProperties.find("[eve-manager-id='gui/components']");
        var aWidgetComponents = oComponent.getParamVal("gui/components");
        //console.error(aWidgetComponents);
        //console.error(oComponent);

        for(var i=0; i<$Elem.length; ++i){
            var $options = $( $Elem[i] ).find("option");

            //Element is not selected
            if(aWidgetComponents[i] == undefined){
                $( $options[0] ).prop("selected",true);         //Select automatically
                setDropDownParam($Elem[i]);                     //Save automatically

                continue;
            }

            for(var j=0; j<$options.length; ++j){

                var $option = $( $options[j] );
                var key;

                for(var k in aWidgetComponents[i]){
                    key = k;
                    break;
                }

                //console.error($option.val());
                console.log($option.val());
                if( $option.val() == aWidgetComponents[i][key] ){

                    $option.prop("selected",true);              //Select format
                    //console.error($option.id);
                    break;
                }
            }
        }
        //Disable Gateway
        $("#componentproperties [eve-manager-components='mainframe'] [eve-manager-id='gateway']").prop("disabled",true);

        updateCustomData(oComponent);

        $Elem = $componentProperties.find("[eve-manager-id='gui/dailyConsumptionAlarmLevel']");
        $Elem.val(oComponent.getParamVal("gui/dailyConsumptionAlarmLevel"));
        $Elem = $componentProperties.find("[eve-manager-id='gui/instantConsumptionAlarmLevel']");
        $Elem.val(oComponent.getParamVal("gui/instantConsumptionAlarmLevel"));

        $Elem = $componentProperties.find("[eve-manager-id='gui/euroF1']");
        $Elem.val(oComponent.getParamVal("gui/euroF1"));
        $Elem = $componentProperties.find("[eve-manager-id='gui/euroF2']");
        $Elem.val(oComponent.getParamVal("gui/euroF2"));
        $Elem = $componentProperties.find("[eve-manager-id='gui/euroF3']");
        $Elem.val(oComponent.getParamVal("gui/euroF3"));
        $Elem = $componentProperties.find("[eve-manager-id='gui/euroF4']");
        $Elem.val(oComponent.getParamVal("gui/euroF4"));

      //  console.log(oComponent.encodeJSON().[]);


    };
}
catch(err){
    console.error(err);
}
