/** Id generator
 *
 * @class EveIdAssign
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 */
"use strict";

function EveIdAssign(strBaseName){
	/** This class instance
	 * @private
	 */
	var self = this;
	
	/** Base Word id
	 * @private
	 * @type string
	 * @default ""
	 */
	//var m_strBaseWord = "";
	var m_strBaseWord = (strBaseName != undefined)?strBaseName:"";
	
	/** Next id
	 * @private
	 * @type Integer
	 * @default 0
	 */
	var m_iNextId = 0;
	
	/** Get next free id
	 * @returns {Integer} free Id
	 */
	this.getId = function(){
		var iRntId = m_iNextId;
		m_iNextId++;
		
		return m_strBaseWord + iRntId;
	};
};