﻿/** Eve Manager: Static methods
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 *
 *
 * @requires <a href="http://jquery.com/">jQuery framework</a>
 */
"use strict";

/** Node search method used by {@link EveManager} object
 * @function
 */
Node.prototype.getNodeByType = function(strType,aComponents){
	var oComponent = this.getData();
	var strComponentType = ((oComponent && oComponent.getType)?oComponent.getType():undefined);
	aComponents = aComponents || new Array();
	
	if(strType == strComponentType){
		aComponents.push(this);
	}
	
	for(var i=0; i < this.children.length; ++i){
		this.children[i].getNodeByType(strType,aComponents);
	}
	
	return aComponents; 
};
	
/** Window resize function adapt all div or element resize
 * @function
 */
var onWindowResize = function(e){
	var $window = $(window);
	var $tabs = $("#tabs");
	var $panels = $("#interface, #createcomponents, #gateways");
	
	//63
	var winOffset = 10;// + parseInt($("#debug_bar").height(),10);
	var tabOffset = 45;// + parseInt($("#debug_bar").height(),10);
	
	//Main table resize
	$tabs.height($window.height() - winOffset);
	
	//Inner panels resize
	$panels.height($tabs.height() - tabOffset);
	
	w2ui['interface'].resize();
	w2ui['createcomponents'].resize();
	w2ui['gateways'].resize();
	
	$("#interface-maps .maps-container").height($("#tabs").height() - 90);
	$("#interface-maps .maps-container .ui-tabs-panel").height($("#tabs").height() - 153);
	
	$("#gateways .gateways").height($("#tabs").height() - 65);
	
	//$("#componentscontainer").css("background-color","red");
	$("#mycomponents").height($("#tabs").height() - 65);
	$("#componentscontainer").height($("#mycomponents").height() - 2);
	//$("#componentscontainer").height($("#mycomponents").height());
};

/** Build a jQuery object rapresenting html default element used for scenario composition actions
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default list element
 */
function getScenarioActionHtmlElement(){
	var $element = $("<li></li>");
	var $category = $("<span></span>");
	var $name = $("<span></span>");
	var $wrapper = $("<div></div>");
	var $dropDown = $("<select></select>");
	var $value = $("<input type='text'></input>");
	var $duration = $("<input type='text'></input>");
	//var $remove = $("<button type='button'>-</button>");
	var $remove = $("<span>&nbsp;</span>");

	//
	$category.addClass("category");
	$name.addClass("name");
	$wrapper.addClass("wrapper");
	$dropDown.addClass("options");
	$value.addClass("value");
	$duration.addClass("duration");
	$remove.addClass("remove");
	$remove.addClass("ui-icon").addClass("ui-icon-trash");

	//Create element html

	$wrapper.append($category);
	$wrapper.append($name);
	$element.append($remove);
	$element.append($wrapper);
	$element.append($dropDown);
	$element.append($value);
	$element.append($duration);

	return $element;
};

/** Build a jQuery object rapresenting html default element used for scenario attached component
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default list element
 */
function getScenarioAttachHtmlElement(){
	var $element = $("<li></li>");
	var $categoryTxt = $("<span dictionary='"+_D("Category")+"'>"+ _D("Category") +": </span>");					//Create category text
	var $category = $("<span></span>");
	var $nameTxt = $("<span dictionary='"+_D("Name")+"'>"+ _D("Name") +": </span>");								//Create name text
	var $name = $("<span></span>");
	var $loop = $("<input type='checkbox'></input><span dictionary='Loop'>"+ _D("Loop") +"</span>");			    //Create loop checkbox
	var $reverse = $("<input type='checkbox'></input><span dictionary='Start when off'></span>");									//Create loop checkbox
	//var $remove = $("<button type='button'>-</button>");
	var $remove = $("<span>&nbsp;</span>");

	//
	$category.addClass("category-txt");
	$name.addClass("name-txt");
	$loop.addClass("loop");
	$reverse.addClass("reverse");

	$remove.addClass("remove");
	$remove.addClass("ui-icon").addClass("ui-icon-trash");
	$element.addClass("attached");                                                     //Add "attached" class

	//Create element html
	$element.append($categoryTxt);
	$element.append($category);
	$element.append($nameTxt);
	$element.append($name);
	$element.append($reverse);
	$element.append($("<span>&nbsp;</span>"));

	$element.append($loop);
	$element.append($remove);

	return $element;
};
	
/** Build a jQuery object rapresenting html default element used for user interface
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default list element
 */
function getInterfaceHtmlElement(){
	var $element = $("<li></li>");
	var $category = $("<span></span>");
	var $name = $("<span></span>");
	var $icon = $("<span></span>");
	var $canvas = $("<canvas></canvas>");
	var $span = $("<span></span>");
	
	//Set class or attributes
	$category.addClass("category");
	$name.addClass("name");
	$icon.addClass("icon");
	//$canvas.addClass("icon");
	
	//$canvas.attr("width",128);
	//$canvas.attr("height",128);
	
	//Create element html
	//$icon.append($span);
	$icon.append($canvas);
	$element.append($icon);
	$element.append($name);
	
	return $element;
};

/** Build a jQuery object rapresenting html default group element
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default components group element
 */
function getGroupHtmlElement(){
	var $element = $("<div></div>");
	var $head = $("<h3><span class='group-text'>&nbsp;</span></h3>");
	var $list = $("<ul></ul>");
	
	$list.css("padding","32px");																//Empty list set height
	$element.append($head);																		//Append header in group container
	$element.append($list);																		//Append content in group container
	
	return $element;
};

/** Build a jQuery object rapresenting html default component element
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default components group element
 */
function getComponentHtmlElement(){
	var $element = $("<li></li>");
	var $icon = $("<span></span>");
	var $text = $("<span></span>");
	var $canvas = $("<canvas></canvas>");




	var $values = $("<span>n.d.</span>");

	$icon.addClass("eve-manager-icon");
	//$icon.addClass("icon");
	//$icon.addClass("icon-set-state_1-64x64");
	$text.addClass("components-text");
    $values.addClass("eve-values");

	//$icon.append($canvas);
	$element.append($icon);
	$element.append($text);
	$element.append($values);

	return $element;
};

function getComponentHtmlElementForMapList(){
	var $element = $("<li></li>");
//	var $icon = $("<span></span>");
	var $text = $("<span></span>");
	var $canvas = $("<canvas></canvas>");
	var $values = $("<span>n.d.</span>");

//	$icon.addClass("eve-manager-icon");
	//$icon.addClass("icon");
	//$icon.addClass("icon-set-state_1-64x64");
	$text.addClass("components-text");
	$values.addClass("eve-values");

	//$icon.append($canvas);
//	$element.append($icon);
	$element.append($text);
	$element.append($values);

	return $element;
};
	
/** Build a jQuery object rapresenting html default gateway element
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default list element
 */
function getGatewayHtmlElement(){
	var $element = $("<li></li>");
	var $name = $("<div></div>");
	//var $addressTxt = $("<span>Address:</span>");
	var $protocolTxt = $("<span dictionary='"+_D("Protocol")+"'>"+_D("Protocol")+"</span>");
	var $protocol = $("<span></span>");
	var $delete = $("<span></span>");
	//var $port = $("<span></span>");
	
	//Set class or attributes
	$element.addClass("gateway"); 
	$name.addClass("ui-widget-header");
	$name.addClass("name");
	$protocolTxt.addClass("protocolTxt");
	$protocol.addClass("protocol");
	$delete.addClass("ui-icon");
	$delete.addClass("ui-icon-close");
	$delete.addClass("remove");
	//$port.addClass("port");
	
	//Create element html
	$element.append($name);
	$element.append($protocolTxt);
	$element.append($protocol);
	$element.append($delete);
	//$element.append($port);
	
	return $element;
};

/** Build an javascript object contains two jQuery object rapresenting default map html code
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default list element
 */
function getMapHtmlElements(){
	var oResponse = {};
	
	// List element template
	var $li = $("<li></li>");
	var $linkedTab = $("<a></a>");
	var $icon = $("<span></span>");
	
	$icon.addClass("ui-icon");
	$icon.addClass("ui-icon-gear");
	
	$linkedTab.css("margin-left","16px");
	$icon.css("cursor","pointer");
	
	$li.append($linkedTab);
	$li.append($icon);
	
	oResponse.header = $li;
	
	// Tab content template
	var $container = $("<div></div>");
	var $zoomPicker = getZoomPickerHtml();
	var $viewer = $("<div class='viewer'>");
	
	//$container.append($zoomPicker);
	$container.append($viewer);
	
	oResponse.contents = $container;
	
	return oResponse;
};

/** Build an javascript object contains two jQuery object rapresenting default map html code
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default list element
 */
function getZoomPickerHtml(){
	return $("<div class='zoom-info zoom-value' style='width:72px; margin-top:20px; margin-left:70px;'>n.d.</div><div class='zoom-info zoom-in' style='margin-top:20px; margin-left:20px; cursor:pointer;'><span class='ui-icon ui-icon-plusthick'>&nbsp;</span></div><div class='zoom-info zoom-out' style='margin-top:20px; margin-left:152px; cursor:pointer;'><span class='ui-icon ui-icon-minusthick'>&nbsp;</span></div>");
};

/** Build a jQuery object rapresenting maps's draggable element
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default list element
 */
function getMapElementHtml(){
	var $elem = $("<div></div>");
	//var $name = $("<span></span>");
	var $label = $("<span></span>");
	//var $icon = $("<span></span>");
	var $icon = $("<canvas></canvas>");
	
	$icon.addClass("icon");
//	$name.addClass("name");
    $label.addClass("label");

	$elem.append($icon);
	$elem.append($label);
	//$elem.append($name);
	
	$elem.addClass("map-element");
	
	return $elem;
};

/** Build a jQuery object rapresenting maps's draggable element
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default list element
 */
function getRelationElementHtml(){
    var $li = $("<li></li>");
    var $status = $("<span></span>");
    var $source = $("<span></span>");
    var $destination = $("<span></span>");
    var $operator = $("<span><span></span></span>");
    var $checkTime = $("<input type='text'></input>");
    var $remove = $("<span><span></span></span>");

    $li.addClass("relation").addClass("incomplete");
    $status.addClass("status").addClass("ui-icon").addClass("ui-icon-circle-close");
    $source.addClass("source").addClass("ui-corner-all").addClass("ui-widget-content");
    $destination.addClass("destination").addClass("ui-corner-all").addClass("ui-widget-content");//.addClass("ui-state-disabled");
    $operator.addClass("operator").addClass("ui-state-default").addClass("ui-corner-all");
    $operator.find("span").addClass("ui-icon").addClass("ui-icon-carat-1-e");
    $checkTime.addClass("checkTime");
    $remove.addClass("remove").addClass("ui-state-default").addClass("ui-corner-all");
    $remove.find("span").addClass("ui-icon").addClass("ui-icon-closethick");

    $source.attr("title",_D("Drag a component")).attr("dictionary-title","Drag a component").attr("dictionary","Drag a component");
    $destination.attr("title",_D("Drag a component")).attr("dictionary-title","Drag a component").attr("dictionary","Drag a component");
    $operator.attr("operator","UNIDIRECTIONAL");

    $source.text("Drag a component");
    $destination.text("Drag a component");

    //$li.append($status);
    $li.append($source);
    $li.append($operator);
    $li.append($destination);
    //$li.append("<span dictionary='Delay'>"+ _D("Delay") +"</span>");
    $li.append($checkTime);
    $li.append($remove);

    return $li;
};

/** Build a jQuery object rapresenting maps's draggable element
 * @function
 * @required <a href="http://jquery.com/">jQuery</a>
 * @returns {jQuery} jQuery default list element
 */
function getPluginElementHtml(){
    var $li = $("<li></li>");
    var $name = $("<span></span>");
    var $icon = $("<img />");
    var $version = $("<span></span>");
    var $date = $("<span></span>");

    var $download = $("<span></span>");
    var $install = $("<span></span>");
    var $config = $("<span></span>");
    var $upload = $("<input type='checkbox' name='uploadPlugin'/>");
    var $remove = $("<span></span>");
    

    //$li.attr("eve-manager-plugin",json[i].id);
    //$li.attr("title",json[i].description);
    //$download.attr("eve-manager-url",json[i].url);
    //$icon.attr("src",json[i].iconurl);

    $download.attr("title",_D("download/update"));
    $install.attr("title",_D("install"));
    $config.attr("title",_D("configure"));
    //$config.attr("title",_D("upload"));
    $remove.attr("title",_D("remove"));
    
    $upload.attr("title",_D("install plugin to EVE"));

    //$name.text(json[i].name);
    //$version.text(json[i].ver);
    //$date.text( json[i].data );

    $name.addClass("name");
    $version.addClass("version");
    $icon.addClass("icon");
    $date.addClass("date");
    $download.addClass("download").addClass("ui-icon").addClass("ui-icon-arrowthickstop-1-s");
    $install.addClass("install").addClass("ui-icon").addClass("ui-icon-transferthick-e-w");
    $config.addClass("config").addClass("ui-icon").addClass("ui-icon-gear");
    $remove.addClass("remove").addClass("ui-icon").addClass("ui-icon-circle-close");
    $upload.addClass("upload-plugin");
  

    $li.append($icon);
    $li.append($name);
    $li.append($version);


    //$li.append($download);
   // $li.append($install);
    $li.append($upload);
    $li.append($config);
    $li.append($remove);
    


    return $li;
};

/*
 * sort local plugin file names, puts eve logic on top
 */
function sortLocalPluginsFileName(fileList) {
	
	if(fileList.length >1) {
		for(var i = 1; i<fileList.length; i++) {
	
			if(fileList[i].name.toLowerCase().trim() == 'evelogic.json') {
				fileList.unshift(fileList[i]);
				fileList.splice(i+1,1);
			}
		}
	}
	return fileList;
}

/** Vimar Group Address Converter
 */
function vimarGroupAdrConverter(nAdr){

    var A = (nAdr >> 11) & 0x1f;

    var B = (nAdr >> 8) & 0x07;

    var C = (nAdr) & 0xff;

    return A + "/"+ B +"/"+ C;
};

/** Vimar Physical Address Converter
 */
function vimarPhAdrConverter(nAdr){

    var A = ( (nAdr >> 12) & 0x0f );

    var B = ( (nAdr >> 8) & 0x0f );

    var C = ( (nAdr) & 0xff );

    return A + "."+ B +"."+ C;
};